Welcome to Subscribe On Youtube

Formatted question description: https://leetcode.ca/all/630.html

630. Course Schedule III

Level

Hard

Description

There are n different online courses numbered from 1 to n. Each course has some duration (course length) t and closed on dth day. A course should be taken continuously for t days and must be finished before or on the dth day. You will start at the 1st day.

Given n online courses represented by pairs (t,d), your task is to find the maximal number of courses that can be taken.

Example:

Input: [[100, 200], [200, 1300], [1000, 1250], [2000, 3200]]

Output: 3

Explanation:

There’re totally 4 courses, but you can take 3 courses at most:

First, take the 1st course, it costs 100 days so you will finish it on the 100th day, and ready to take the next course on the 101st day.

Second, take the 3rd course, it costs 1000 days so you will finish it on the 1100th day, and ready to take the next course on the 1101st day.

Third, take the 2nd course, it costs 200 days so you will finish it on the 1300th day.

The 4th course cannot be taken now, since you will finish it on the 3300th day, which exceeds the closed date.

Note:

  1. The integer 1 <= d, t, n <= 10,000.
  2. You can’t take two courses simultaneously.

Solution

Core Principle: Prioritize completing courses with shorter durations first.

Begin by sorting the courses by their deadlines. It is strategically advantageous to select courses with earlier deadlines.

Employ a priority queue that extracts the maximum element first. For each course, consider its duration and deadline.

  • If the current course can be completed by its deadline (accounting for the cumulative days spent on previously selected courses), then:
    • Insert the course’s duration into the priority queue.
    • Increment the total days by the course’s duration.
    • Increase the course completion count by 1.
  • If the current course cannot be completed by its deadline, assess whether the longest course duration currently in the priority queue is longer than the duration of the current course.
    • If this condition holds, substitute the longest course duration in the priority queue with the duration of the current course and adjust the total days accordingly.

In conclusion, the method returns the total number of courses that can feasibly be completed.

This approach ensures that the maximum number of courses are completed within their respective deadlines, by strategically choosing shorter courses first and replacing longer courses with shorter ones when necessary to optimize the schedule.

  • 
    public class Course_Schedule_III {
    
    
        // https://leetcode.com/articles/course-schedule-iii/
        public class Solution {
            public int scheduleCourse(int[][] courses) {
    
                Arrays.sort(courses, (a, b) -> a[1] - b[1]);
                PriorityQueue<Integer> queue = new PriorityQueue<>((a, b) -> b - a); // duration time放入heap
    
                int time = 0;
                for (int[] c: courses) {
                    if (time + c[0] <= c[1]) {
                        queue.offer(c[0]);
                        time += c[0];
                    } else if (!queue.isEmpty() && queue.peek() > c[0]) {
                        time += c[0] - queue.poll();
                        queue.offer(c[0]);
                    }
                }
    
                return queue.size();
            }
        }
    }
    
    ############
    
    class Solution {
        public int scheduleCourse(int[][] courses) {
            Arrays.sort(courses, Comparator.comparingInt(a -> a[1]));
            PriorityQueue<Integer> pq = new PriorityQueue<>((a, b) -> b - a);
            int s = 0;
            for (int[] course : courses) {
                int duration = course[0], lastDay = course[1];
                pq.offer(duration);
                s += duration;
                if (s > lastDay) {
                    s -= pq.poll();
                }
            }
            return pq.size();
        }
    }
    
  • // OJ: https://leetcode.com/problems/course-schedule-iii/
    // Time: O(NT)
    // Space: O(NT)
    class Solution {
        vector<vector<int>> memo;
        int dp(vector<vector<int>> &A, int i, int time) {
            if (i == A.size()) return 0;
            if (memo[i][time] != -1) return memo[i][time];
            int pick = 0;
            if (time + A[i][0] <= A[i][1]) pick = 1 + dp(A, i + 1, time + A[i][0]);
            int skip = dp(A, i + 1, time);
            return memo[i][time] = max(pick, skip);
        }
    public:
        int scheduleCourse(vector<vector<int>>& A) {
            sort(begin(A), end(A), [](auto &a, auto &b) { return a[1] < b[1]; });
            memo.assign(A.size(), vector<int>(A.back()[1] + 1, -1));
            return dp(A, 0, 0);
        }
    };
    
  • # idea:
    # sort all courses by deadline
    # iterate all sorted courses
    # if current course is able to be taken, then take it
    # if not, check if we can remove some courses from courses we already taken
    # if the one has the maximal duration is greater than current course's duration
    # then replace it by current course
    # since courses are already sorted by deadline, then our new deadline must be later
    # (why? because sorted by deadline, current deadline must be later than all deadlines of taken courses, 
    # so it must be valid)
    # moreover, we have more available time for taking more courses
    
    class Solution(object):
      def scheduleCourse(self, courses):
        """
        :type courses: List[List[int]]
        :rtype: int
        """
        now = 0
        heap = []
        for t, d in sorted(courses, key=lambda x: x[1]):
          if now + t <= d:
            now += t
            heapq.heappush(heap, -t)
          elif heap and -heap[0] > t:
            # here popped is already negative when being pushed
            now += t + heapq.heappop(heap)
            heapq.heappush(heap, -t)
        return len(heap)
    
    ############
    
    class Solution:
        def scheduleCourse(self, courses: List[List[int]]) -> int:
            courses.sort(key=lambda x: x[1])
            pq = []
            s = 0
            for d, e in courses:
                heappush(pq, -d)
                s += d
                if s > e:
                    s += heappop(pq)
            return len(pq)
    
    
  • func scheduleCourse(courses [][]int) int {
    	sort.Slice(courses, func(i, j int) bool {
    		return courses[i][1] < courses[j][1]
    	})
    
    	h := &Heap{}
    	s := 0
    	for _, course := range courses {
    		if d := course[0]; s+d <= course[1] {
    			s += d
    			heap.Push(h, d)
    		} else if h.Len() > 0 && d < h.IntSlice[0] {
    			s += d - h.IntSlice[0]
    			h.IntSlice[0] = d
    			heap.Fix(h, 0)
    		}
    	}
    	return h.Len()
    }
    
    type Heap struct {
    	sort.IntSlice
    }
    
    func (h Heap) Less(i, j int) bool {
    	return h.IntSlice[i] > h.IntSlice[j]
    }
    
    func (h *Heap) Push(x interface{}) {
    	h.IntSlice = append(h.IntSlice, x.(int))
    }
    
    func (h *Heap) Pop() interface{} {
    	a := h.IntSlice
    	x := a[len(a)-1]
    	h.IntSlice = a[:len(a)-1]
    	return x
    }
    
  • function scheduleCourse(courses: number[][]): number {
        courses.sort((a, b) => a[1] - b[1]);
        const pq = new MaxPriorityQueue();
        let s = 0;
        for (const [duration, last] of courses) {
            pq.enqueue(duration);
            s += duration;
            while (s > last) {
                s -= pq.dequeue().element;
            }
        }
        return pq.size();
    }
    
    

All Problems

All Solutions